--Wanderer
--This NPC wanders about randomly. 
--It doesn't try to stay in any particular area, so it may wander off.

require 'middleclass.init'

require("mobiles.lua")

Wanderer = Mobile:subclass('Wanderer')

function Wanderer:initialize()
    Mobile.initialize(self)
    
    self.originx = self.worldx
    self.originy = self.worldy
    
    self.walktime = 0
    self.pausetime = 0
    self.nextwalklimit = 1
    self.nextpauselimit = 1
    self.walkx = 1
    self.walky = 0
    
    print("Initting Wanderer")
end

function Wanderer:thunk(dt)
    --Pick a direction
    --Go that direction for 1 second
    --Pause for 1 second
    --Restart
    
    local modx = 0
    local mody = 0
    
    --If we're still okay to walk:
    if self.walktime < self.nextwalklimit then
        if self.walkx ~= 0 or self.walky ~= 0 then
            self.moving = true
        end
        modx = self.walkx*dt
        mody = self.walky*dt
        self.walktime = self.walktime+dt
        self.pausetime = 0
    --If we're not okay to walk and are under our pause budget:
    elseif self.pausetime < self.nextpauselimit then
        self.moving = false
        self.pausetime = self.pausetime+dt
    --We've walked too long and paused too long, so we'll walk next thunk.
    else
        self.walktime = 0
        
        --Randomly choose between (-1, 0, 1) for self.walkx and self.walky
        self.walkx = (math.random(2)-math.random(2))*self.speed
        self.walky = (math.random(2)-math.random(2))*self.speed
        
        --Set self.direction based on what the walkx/y is
        if self.walkx < 0 then self.direction = "left"
        elseif self.walkx > 0 then self.direction = "right" 
        elseif self.walky < 0 then self.direction = "up"
        elseif self.walky > 0 then self.direction = "down" end
        
    end
    return {modx, mody}
end