require("helper_functions")

player = {}

--Give our maps a place to put their variables they want to save
player.mapvars = {}

--Spritesheets:
--Each has a number of tiles high and wide, and the number of frames per second. 
--This is defined here because it doesnt differ between spritesheets. 
--Remember to use deepcopy() later so you dont end up with a reference to the same table 4 times.
local basetable = {tiles_height=2, tiles_width=2, fps=5}

--Four directions, up, down, left, right
player.up = deepcopy(basetable)
player.down = deepcopy(basetable)
player.left = deepcopy(basetable)
player.right = deepcopy(basetable)

--Each direction has a filename
player.up.filename = "gfx/player_up_spritesheet.png"
player.down.filename = "gfx/player_down_spritesheet.png"
player.left.filename = "gfx/player_left_spritesheet.png"
player.right.filename = "gfx/player_right_spritesheet.png"

--Where should we put our player at the beginning of the game?
player.start = {}
player.start.x = 4
player.start.y = 4
player.start.map = "initial"
player.start.direction = "down"

--Player Info
player.name = "Player"
player.sex = "Male"
player.otid = math.random(0, 65535)

--A player's current monsters on hand
player.monsters = {}
player.monsters[1] = monsters.puppy()
player.monsters[1].nickname = player.monsters[1].propername
player.monsters[1].originaltrainer = player.otid
player.monsters[1].originaltrainername = player.name

--A player's monster index, a list of what monsters they've caught.
player.monsterindex = {}
player.monsterindex[player.monsters[1].propername] = true






