
--Copyright 2010 Gryc Ueusp

--This file is part of Collectible RPG Engine.

--Collectible RPG Engine is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.

--Collectible RPG Engine is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.

--You should have received a copy of the GNU General Public License
--along with Collectible RPG Engine.  If not, see <http://www.gnu.org/licenses/>.



require("math")

function calc_hp_old(monster)
    local iv = monster.ivs.hp
    local base = monster.basestats.hp
    local ev = monster.evs.hp
    local level = monster.level
    return (((iv+base+(math.sqrt(ev)/8)+50)*level)/50)+10
end

function calc_hp_new(monster)
    local iv = monster.ivs.hp
    local base = monster.basestats.hp
    local ev = monster.evs.hp
    local level = monster.level
    return ((((iv+(2*base)+(ev/4)+100)*level)/100)+10)
end

function calculate_damage(level, attack, movedamage, targetdefense, typemod, stab, rand)
--[=[= 

>=calculate_damage(75, 123, 65, 163, 4, 1.5, 1.0)
200

>=calculate_damage(75, 123, 65, 163, 4, 1.5, 0.85)
170

=]=]
	
	local d = 2
	d = d * level
	d = d + 10
	d = d * attack
	d = d * movedamage
	d = d / (250*targetdefense)
	d = d + 2
	d = d * typemod
	d = d * stab
	d = d * rand
	return math.floor(d)
end
    
function calculate_attack(monster, targetmonster, move)
	
	--monster.attack could be monster.special if the attack is a special attack
	
	local stab = 1.0
	for k,m in pairs(move.types) do
        for _, value in pairs(monster.types) do
            if m == value then 
                stab = 1.5
                break
            end
        end
	end
    
	effectiveness = 1.0 
	
	return calculate_damage(monster.level, monster.basestats.attack, 
	move.power, targetmonster.basestats.defense, effectiveness, stab,
	(math.random(85, 100)/100.0))
    
end
